#import <objectbase/SwarmObject.h>

@class Interval;

@interface ASMModelParams: SwarmObject
{
@public
  int numBFagents;  /*" number of BFagents "*/
  Interval *initholding;
  Interval *initialcash;
  Interval *minholding;
  Interval *mincash;
  Interval *intrate;

  //Dividend parameters
  Interval *baseline;   //Also used by World.
  Interval *mindividend;
  Interval *maxdividend;
  Interval *amplitude;
  int period;
  int flattenRho;
  int flattenGauss;
  int exponentialMAs;   //Also used by World.//pj:was BOOL
  //Specialist parameters
  Interval *maxprice;
  Interval *minprice;
  Interval *taup;
  int sptype;
  int maxiterations;
  Interval *minexcess;
  Interval *eta;
  Interval *etamax;
  Interval *etamin;
  Interval *rea;
  Interval *reb;
  int randomSeed;
  int dividendSeed;
  //Agent parameters overridden by the BFagent.  
  //These might be used for other agents that a user implements. 
  Interval *tauv;          
  Interval *lambda;
  Interval *maxbid; 
  Interval *initvar;
  Interval *maxdev;


  int setOutputForData;

  // Parameters for loading floating points (GP)
@private
  double d_initholding;
  double d_initialcash;
  double d_minholding;
  double d_mincash;
  double d_intrate;
  double d_baseline;
  double d_mindividend;
  double d_maxdividend;
  double d_amplitude;
  double d_maxprice;
  double d_minprice;
  double d_taup;
  double d_minexcess;
  double d_eta;
  double d_etamax;
  double d_etamin;
  double d_rea;
  double d_reb;
  double d_tauv;          
  double d_lambda;
  double d_maxbid; 
  double d_initvar;
  double d_maxdev;
};

-init;
-(void)drop;

@end


