#import <objectbase/SwarmObject.h>

@class Interval;

@interface MovingAverage: SwarmObject
{
  int width;  /*"number of observations used for a fixed interval moving average"*/
  int numInputs; /*"number of observations that have already been inserted"*/
 
  
  Interval * *maInputs; /*"historical inputs are kept in this array."*/
  int arrayPosition; /*"element of maInputs that has been most recently inserted"*/
  Interval * sumOfInputs;/*"sum of the last 'width' inputs"*/
  Interval * uncorrectedSum; /*"sum of all inputs since object was created"*/
 
  Interval * expWMA;  //exponentially weighted moving average
  Interval * aweight, * bweight; /*"Weights used to calculate exponentially weighted moving averages.  These depend on the specified 'width' according to: bweight = -expm1(-1.0/w);aweight = 1.0 - bweight; ewma=aweight*ma(x)+bweight*x"*/

} 

+createBegin: zone;
+create: zone;

- initWidth: (int)w;
- initWidth: (int)w Value: (Interval *)val;

- (int)getNumInputs;

- (Interval *)getMA;

- (Interval *)getAverage;

- (Interval *)getEWMA;

- (void)addValue: (Interval *)x;

- (void)drop;

@end












